 <!--left panel contains top toolbar, left toolbar and main view-->
<div 
    layout="row" 
    flex 
    mb-preloading="creatingNewContent || ['waiting', 'loading'].indexOf(ctrl.state)>=0"
    tabindex="0">
    <div
        id="content-editor"
        layout="column"
        flex>

        <!--top toolbar-->
        <md-toolbar
			ng-if="ctrl.isEditorLoaded()"
			ng-show="ctrl.isEditMode()"
            class="md-primary md-hue-2"
        	id="content-editor-top">
            <amh-action-toolbar 
                ng-if="ctrl.isEditorLoaded()"
                ng-show="ctrl.isEditMode()"
                ng-model="ctrl.selectedWidgets">
            </amh-action-toolbar>
        </md-toolbar>

        <!--left toolbar and main content. main content itself contains sidenavs-->
        <div
            id="content-editor-area"
            layout="row"
            flex>

            <!--left toolbar-->
            <md-toolbar
                ng-if="ctrl.isEditorLoaded()"
                ng-show="ctrl.isEditMode()"
                id="content-editor-vertical-toolbar"
                class="md-primary md-hue-2"
                layout="column"
                layout-align="start stretch">

                <md-button
                    class="md-icon-button editor-action"
                    ng-click="ctrl.toggleSidenav('add')">
                    <wb-icon>add</wb-icon>
                    <md-tooltip 
                    	md-direction="{{app.dir==='rtl' ? 'left' : 'right'}}" 
                    	md-delay="1500">
                    	<span translate>Add widget to page</span>
                    </md-tooltip>
                </md-button>

                <md-button 
                    class="md-icon-button editor-action"
                    ng-click="ctrl.toggleSidenav('pages')">
                    <wb-icon>pages</wb-icon>
                    <md-tooltip md-direction="{{app.dir==='rtl' ? 'left' : 'right'}}" md-delay="1500">List of all pages</md-tooltip>
                </md-button>

                <md-divider layout-margin></md-divider>

                <md-button 
                    class="md-icon-button editor-action"
                    ng-click="ctrl.toggleSidenav('general-settings')">
                    <wb-icon>settings_applications</wb-icon>
                    <md-tooltip md-direction="{{app.dir==='rtl' ? 'left' : 'right'}}" md-delay="1500">Page settings</md-tooltip>
                </md-button>

                <md-button 
                    class="md-icon-button editor-action"
                    ng-click="ctrl.showPreview()">
                    <wb-icon>pageview</wb-icon>
                    <md-tooltip md-direction="{{app.dir==='rtl' ? 'left' : 'right'}}" md-delay="1500">Preview</md-tooltip>
                </md-button>

                <md-divider layout-margin></md-divider>

                <md-button 
                    class="md-icon-button editor-action"
                    ng-click="ctrl.openHelp()">
                    <wb-icon>help</wb-icon>
                    <md-tooltip md-direction="{{app.dir==='rtl' ? 'left' : 'right'}}" md-delay="1500">General help</md-tooltip>
                </md-button>

                <md-button
                    class="md-icon-button editor-action"
                    ng-click="ctrl.toggleSidenav('content-setting-panel')"
                    ng-if="!ctrl.isSidenavOpen('content-setting-panel')">
                    <wb-icon>menu</wb-icon>
                </md-button>

                <span flex></span>

                <md-button 
                    class="md-icon-button editor-action"
                    flex="10"
                    ng-click="ctrl.toggleSidenav('templates')">
                    <wb-icon>perm_media</wb-icon>
                    <md-tooltip md-direction="{{app.dir==='rtl' ? 'left' : 'right'}}" md-delay="1500">Existing templates</md-tooltip>
                </md-button>
            </md-toolbar>

            <!--main content-->
            <md-content 
                id="content-editor-veiw"
                layout="row"
                flex>
                <!--left sidenavs-->
                <!--widgets list-->
                <md-sidenav 
	                ng-if="ctrl.isEditorLoaded()"
	                ng-show="ctrl.isEditMode()"
                    id="content-editor-sidenav-widget" 
                    md-component-id="add"                        
                    md-disable-backdrop 
                    md-whiteframe="4"
                    ng-class="{'md-sidenav-right': app.dir === 'rtl', 'md-sidenav-left': app.dir !== 'rtl'}"
                    class="md-hue-2"
                    layout="row"
                    ng-cloak>
                    <md-content 
                        flex>
                        <wb-widgets-explorer 
                            ng-model="ctrl.widgets">
                        </wb-widgets-explorer>
                    </md-content>
                </md-sidenav>

                <!--pages list-->
                <md-sidenav 
	                ng-if="ctrl.isEditorLoaded()"
	                ng-show="ctrl.isEditMode()"
                    id="content-editor-sidenav-pages" 
                    layout="row"
                    md-component-id="pages"
                    md-disable-backdrop 
                    md-whiteframe="4"
                    ng-class="{'md-sidenav-right': app.dir === 'rtl', 'md-sidenav-left': app.dir !== 'rtl'}"
                    class="md-hue-2">

                    <md-content
                        ng-controller="AmhContentPagesCtrl as pageCtrl"
                        mb-infinate-scroll="pageCtrl.loadNextPage()"
                        mb-preloading="pageCtrl.state !== 'ideal'"
                        flex>

                        <!--  Action bar -->
                        <mb-pagination-bar
                            mb-model="pageCtrl.queryParameter"
                            mb-reload="pageCtrl.reload()"
                            mb-sort-keys="pageCtrl.getProperties()"
                            mb-more-actions="pageCtrl.getActions()">
                        </mb-pagination-bar>

                        <md-list flex>
                            <md-list-item 
                                class="md-2-line" 
                                ng-repeat="page in pageCtrl.items" 
                                ng-href="/content/{{page.id}}">
                                <div class="md-list-item-text" layout="column">
                                    <h3>{{ page.title}}</h3>
                                    <h4>{{ page.description}}</h4>
                                </div>
                            </md-list-item>
                        </md-list>
                    </md-content>
                </md-sidenav>

                <!--templates list-->
                <md-sidenav 
	                ng-if="ctrl.isEditorLoaded()"
	                ng-show="ctrl.isEditMode()"
                    id="content-editor-sidenav-pages" 
                    md-component-id="templates"
                    md-disable-backdrop 
                    md-whiteframe="4"
                    ng-class="{'md-sidenav-right': app.dir === 'rtl', 'md-sidenav-left': app.dir !== 'rtl'}"
                    class="md-hue-2">

                    <md-toolbar 
                        class="content-sidenavs-toolbar"
                        layout="row"
                        layout-align="start center"> 
                        <span translate="">Templates</span>
                    </md-toolbar>

                    <md-content
                        ng-controller="AmhTemplateCtrl as templateCtrl"
                        layout="column"
                        layout-align="start center"
                        layout-wrap
                        mb-preloading="loadingTemplatePreview || savingContent">
                        <md-card 
                            ng-repeat="template in templates track by template.name"
                            flex-xs flex-gt-xs="none" 
                            layout="column"
                            class="amh-core-themplate-card">
                            <!-- Thumbnail -->
                            <img 
                                ng-click="templateCtrl.showPreviewOf(template)"
                                ng-src="{{template.thumbnail}}" 
                                class="amh-core-themplate-card-image" 
                                alt="{{template.name}}"> 
                            <!-- Actions -->
                            <md-card-actions 
                                layout="row" 
                                layout-align="end center">
                                <md-button 
                                    ng-click="templateCtrl.showPreviewOf(template)"
                                    aria-label="Favorite">
                                    <span translate>Preview</span>
                                </md-button>
                                <md-button 
                                    ng-click="ctrl.setTemplate(template)"
                                    aria-label="install">
                                    <span translate="">Apply</span>
                                </md-button>
                            </md-card-actions>
                        </md-card>
                    </md-content>
                </md-sidenav>


                <!--Page settings: contains the setting of main page-->
                <md-sidenav 
	                ng-if="ctrl.isEditorLoaded()"
	                ng-show="ctrl.isEditMode()"
                    id="content-editor-general-setting" 
                    md-component-id="general-settings"
                    md-disable-backdrop 
                    md-whiteframe="4"
                    ng-class="{'md-sidenav-right': app.dir === 'rtl', 'md-sidenav-left': app.dir !== 'rtl'}"
                    class="md-hue-2">
                    <md-toolbar 
                        class="content-sidenavs-toolbar"
                        layout="row"
                        layout-align="start center"> 
                        <span translate>Page settings</span>
                    </md-toolbar>
                    <md-content 
                        flex>
                        <wb-setting-panel-group 
                            id="content-editor-setting"
                            ng-model="rootWidget">
                        </wb-setting-panel-group>
                    </md-content>
                </md-sidenav>

                <!-- main content: depends on the type of content -->
                <md-content
                    flex>
                    <wb-group
                        ng-if="ctrl.type === 'weburger'"
                        wb-on-model-under-cursor="ctrl.widgetUnderCursor($event)"
                        wb-on-model-select="loadSettings($event)"
                        wb-editable="ctrl.isEditMode()"
                        ng-model="model">
                    </wb-group>
                </md-content>

                <img 
                	id="content-type-image"
                    ng-if="type === 'image'"
                    ng-src="/api/v2/cms/contents/{{content.id}}/content"
                    alt="{{content.title}}">
                <audio 
                	id="content-type-audio"
                    ng-if="type === 'audio'"
                    controls>
                    <source 
                    	src="/api/v2/cms/contents/{{content.id}}/content" 
                    	type="{{content.mime_type}}">
                    <span translate>Your browser does not support the audio tag.</span>
                </audio>
                <video 
                	id="content-type-video"
                    ng-if="type === 'video'"
                    controls>
                    <source 
                    	src="/api/v2/cms/contents/{{content.id}}/content" 
                    	type="{{content.mime_type}}">
                    <span translate>Your browser does not support the video tag.</span>
                </video>
                <div
                    ng-if="error.status === 404">
                    <wb-group
                        ng-if="app.config.pageNotFound"
                        wb-editable="false" 
                        ng-model="app.config.pageNotFound"
                        flex>
                    </wb-group>
                    <div ng-if="!app.config.pageNotFound">
                        <h2 translate="">Page not found</h2>
                        <p translate="">This page does not exist.</p> 
                    </div>
                    <div
                        ng-if="app.user.owner"
                        layout="row"
                        layout-align="center center">
                        <md-button 
                            ng-click="ctrl.createContent()">
                            <span translate>Create this page</span>
                        </md-button>
                    </div>
                </div>
            </md-content>
        </div>
        <amh-widget-path 
			ng-if="ctrl.isEditorLoaded()"
			ng-show="ctrl.isEditMode()"
            ng-model="ctrl.selectedWidgets">
        </amh-widget-path>
    </div>

    <!--right panel: contains the setting of each selected widget-->

    <!--Description of each item in setting panel is set in 'setting' service in am-wb-core.-->
    <!--if it's needing, the description fields of item should be set up there.-->
    <!--if so, the description will be shown on a tooltip over every item--> 
    <md-sidenav 
        ng-if="ctrl.isEditorLoaded()"
        ng-show="ctrl.isEditMode()"
        id="content-setting-panel"
        layout="row"
        class="md-sidenav-right"
        md-component-id="content-setting-panel"
        md-is-locked-open="$mdMedia('gt-md')"
        md-whiteframe="4"
        flex="20">
        <md-tabs 
            flex="">
            <md-tab>
                <md-tab-label>
                    <wb-icon>color_lens</wb-icon>
                </md-tab-label>
                <md-tab-body>
                    <md-content 
                        ng-if="selectedWidget"
                        flex>
                        <wb-setting-panel-group 
                            id="content-editor-setting"
                            ng-model="selectedWidget">
                        </wb-setting-panel-group>
                    </md-content>
                </md-tab-body>
            </md-tab>
            <!-- TODO: maso,2018: enable widget events -->
            <md-tab
                ng-if="false">
                <md-tab-label>
                    <wb-icon>flash_on</wb-icon>
                </md-tab-label>
                <md-tab-body>
                    <md-content 
                        ng-if="selectedWidget"
                        flex>
                        <!-- TODO: maso, 2018: enable widget events -->
                        <wb-events-panel-group 
                            id="content-editor-events"
                            ng-model="selectedWidget">
                        </wb-events-panel-group>
                    </md-content>
                </md-tab-body>
            </md-tab>
            <md-tab>
                <md-tab-label>
                    <wb-icon>flash_on</wb-icon>
                </md-tab-label>
                <md-tab-body>
                    <md-content 
                        flex>
                        <wb-event-panel ng-model="selectedWidget"></wb-event-panel>
                    </md-content>
                </md-tab-body>
            </md-tab>
            <md-tab>
                <md-tab-label>
                    <wb-icon>photo_album</wb-icon>
                </md-tab-label>
                <md-tab-body>
                    <md-content 
                        flex>
                        <!-- TODO: maso, 2018: enable widget events -->
                        <amh-user-widgets 
                            id="content-editor-user-widgets">
                        </amh-user-widgets>
                    </md-content>
                </md-tab-body>
            </md-tab>
        </md-tabs>
    </md-sidenav>
</div>
